#include <iostream>

using namespace std;

const int MAXN = 100;
typedef int KiMennyiertVallal[MAXN][MAXN];
typedef int MunkaSorszam[MAXN];
// Bemenet
int N;
KiMennyiertVallal F;
int X;
// Kimenet
bool Van;
MunkaSorszam Y;

void Beolvasas(int &N, KiMennyiertVallal F, int &X) {
  for (int i = 0; i < N; i++) {
    for (int j = 0; j < N; j++) {
      F[i][j] = 0;
    }
  }
  
  clog << "Munkak szama (1<=N<=100) = ";
  cin >> N;
  clog << "Hatarosszeg = ";
  cin >> X;
  for (int i = 0; i < N; i++) {
    clog << i + 1 << ". munkas munkai:" << endl;
    for (int j = 0; j < N; j++) {
      clog << "  " <<  j + 1 << ". munkaert kert fizetes (0, ha nem vallalja) = ";
      cin >> F[i][j];
    }
  }
}

int Koltseg(const int i, const int N, const KiMennyiertVallal F, const MunkaSorszam Y) {
  int s = 0;
  for (int j = 1; j <= N; j++) {
    s = s + F[i - 1][Y[j - 1] - 1];
  }
  return s;
}

bool rossz(const int i, const int j, const MunkaSorszam Y) {
  int k = 1;
  while (k < i and Y[k - 1] != j) {
    k = k + 1;
  }
  return k < i;
}

void Joesetkereses(const int i, const int N, const KiMennyiertVallal F, const MunkaSorszam Y, 
                   bool &Van, int &j) {
  j = Y[i - 1] + 1;
  while (j <= N and (rossz(i, j, Y) or F[i - 1][j - 1] == 0)) {
    j = j + 1;
  }
  Van = j <= N;
}

void Munkak(const int N, const KiMennyiertVallal F, const int X,
            bool &Van, MunkaSorszam &Y) {
  for (int i = 0; i <= N - 1; i++) {
    Y[i] = 0;
  }
  int i = 1;
  while (i >= 1 and i <= N) {
    int j;
    Joesetkereses(i, N, F, Y, Van, j);
    if (Van and Koltseg(i, N, F, Y) <= X) {
      Y[i - 1] = j;
      i++;
    } else {
      Y[i - 1] = 0;
      i--;
    }
  }
  Van = i > N;
}

void Kiiras(const int N, const bool Van, const MunkaSorszam Y) {
  if (Van) {
    for (int i = 1; i <= N; i++) {
      cout << Y[i - 1] << " ";
    }
    cout << endl;
  } else {
    cout << "Nincs helyes megoldas" << endl;
  }
}

int main() {
  
  Beolvasas(N, F, X);
  Munkak(N, F, X, Van, Y);
  Kiiras(N, Van, Y);
  
  return 0;
}