#include <iostream>

using namespace std;

const int MAXN = 100;
typedef bool Szomszedok[MAXN][MAXN];
typedef int TeruletSzinek[MAXN];
// Bemenet
int N;
Szomszedok Sz;
int K;
// Kimenet
bool Van;
TeruletSzinek Y;

void Beolvasas(int &N, Szomszedok Sz, int &K) {
  clog << "Teruletek szama (1<=N<=100) = ";
  cin >> N;
  clog << "Szinek szama (1<=K<=100) = ";
  cin >> K;
  for (int i = 0; i < N; i++) {
    clog << i + 1 << ". terulet szomszedos-e" << endl;
    for (int j = 0; j < N; j++) {
      int sv;
      clog << "  a(z) " <<  j + 1 << ". terulettel (0 - nem, 1 - igen) = ";
      cin >> sv;
      Sz[i][j] = sv > 0;
    }
  }
}

bool rossz(const int i, const int j, const Szomszedok Sz, const TeruletSzinek Y) {
  int k = 1;
  while (k < i and (Y[k - 1] != j or !Sz[k - 1][i - 1])) {
    k = k + 1;
  }
  return k < i;
}

void Joesetkereses(const int i, const Szomszedok Sz, const int K, const TeruletSzinek Y, 
                   bool &Van, int &j) {
  j = Y[i - 1] + 1;
  while (j <= K and rossz(i, j, Sz, Y)) {
    j = j + 1;
  }
  Van = j <= K;
}

void Terkep(const int N, const Szomszedok Sz, const int K,
            bool &Van, TeruletSzinek &Y) {
  for (int i = 0; i <= N - 1; i++) {
    Y[i] = 0;
  }
  int i = 1;
  while (i >= 1 and i <= N) {
    int j;
    Joesetkereses(i, Sz, K, Y, Van, j);
    if (Van) {
      Y[i - 1] = j;
      i++;
    } else {
      Y[i - 1] = 0;
      i--;
    }
  }
  Van = i > N;
}

void Kiiras(const int N, const bool Van, const TeruletSzinek Y) {
  if (Van) {
    for (int i = 1; i <= N; i++) {
      cout << Y[i - 1] << " ";
    }
    cout << endl;
  } else {
    cout << "Nincs helyes megoldas" << endl;
  }
}

int main() {
  
  Beolvasas(N, Sz, K);
  Terkep(N, Sz, K, Van, Y);
  Kiiras(N, Van, Y);
  
  return 0;
}