﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace feladat
{
    class Program
    {
        static void Beolvasás(out int N, int[,] F, out int X)
        {
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Munkák száma és határösszeg, szóközzel elválsztva: ");
            string input = Console.ReadLine();
            string[] adatok = input.Split(' ');
            N = Convert.ToInt32(adatok[0]);
            X = Convert.ToInt32(adatok[1]);
            for (int i = 0; i < N; i++)
            {
                for (int j = 0; j < N; j++)
                {
                    F[i,j] = 0;
                }
            }
            for (int i = 0; i < N; i++)
            {
                Console.Error.WriteLine((i + 1) + ". munkás munkái: ");
                input = Console.ReadLine();//Egy sorban több adat van
                adatok = input.Split(' ');
                int adatindex = 0;
                for (int j = 0; j < N; j++)
                {
                    Console.Error.WriteLine(" "+(j + 1) + ". munkáért kért fizetés (0, ha nem vállalja): ");
                    F[i,j] = Convert.ToInt32(adatok[adatindex]);
                    adatindex++;
                }
            }
        }

        static int Költség(int i, int N, int[,] F, int[] Y)
        {
            int s = 0;
            for (int j = 1; j <= N; j++)
            {
                if ((Y[j - 1] - 1) >= 0)//Mivel Y még csak részben feltöltött állapotában az Y[j] fals oszlop indexet tartalmaz. Indextúllépést vagy rossz eredményt okozhat
                {
                    s = s + F[i - 1, Y[j - 1] - 1];
                }
            }
            return s;
        }

        static bool rossz(int i, int j, int[] Y)
        {
            int k = 1;
            while (k < i && Y[k - 1] != j)
            {
                k++;
            }
            return k < i;
        }
        
        static void Jóesetkeresés(int i, int N, int[,] F, int[] Y, out bool Van, ref int j)
        {
            j = Y[i - 1] + 1;
            while (j <= N && (rossz(i, j, Y) || F[i - 1,j - 1] == 0))
            {
                j++;
            }
            Van = j <= N;
        }

        static void Munkák(int N, int[,] F, int X, out bool Van, int[] Y)
        {
            for (int ii = 0; ii < N; ii++)
            {
                Y[ii] = 0;
            }
            int i = 1;
            while (i >= 1 && i <= N)
            {
                int j = 0;
                Jóesetkeresés(i, N, F, Y, out Van, ref j);
                if (Van && Költség(i, N, F, Y) <= X)
                {
                    Y[i - 1] = j;
                    i++;
                }
                else
                {
                    Y[i - 1] = 0;
                    i--;
                }
            }
            Van = i > N;
        }

        static void Kiírás(int N, bool Van, int[] Y)
        {
            //A kimenetet kísérő szövegek is az Error csatornára irandók!
            if (Van)
            {
                for (int i = 0; i < N; i++)
                {
                    Console.WriteLine(Y[i] + " ");
                }
                Console.WriteLine();
            }
            else
            {
                Console.WriteLine("Nincs helyes megoldás!");
            }
        }

        static void Main(string[] args)
        {
            //Munkásfelvétel: N állás – N jelentkező
            //Maximális elemszám
            const int MaxN = 100;
            //A munkások száma
            int N;
            int X;
            //A mátrix deklarálása
            int[,] F = new int[MaxN, MaxN]; //Ki mennyiért vállal
            //Kieneti adatok deklarálása
            bool Van;
            int[] Y = new int[MaxN];//Munkasorszám
            //Beolvasás
            Beolvasás(out N, F, out X);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            //Lényegi megoldás
            Munkák(N,F,X,out Van,Y);
            //Kiírás
            Kiírás(N, Van, Y);
        }
    }
}
