﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace feladat
{
    class Program
    {
        static void Beolvasás(out int N, bool[,] Sz, out int K)
        {
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Területek száma és a színek száma, szóközzel elválsztva: ");
            string input = Console.ReadLine();
            string[] adatok = input.Split(' ');
            N = Convert.ToInt32(adatok[0]);
            K = Convert.ToInt32(adatok[1]);
            for (int i = 0; i < N; i++)
            {
                Console.Error.WriteLine((i + 1) + ". terület szomszédos-e: ");
                input = Console.ReadLine();//Egy sorban több adat van
                adatok = input.Split(' ');
                int adatindex = 0;
                for (int j = 0; j < N; j++)
                {
                    int sv;
                    Console.Error.WriteLine(" a(z) "+(j + 1) + ". területtel (0, ha nem, 1 ha igen): ");
                    sv = Convert.ToInt32(adatok[adatindex]);
                    adatindex++;
                    Sz[i,j] = (sv > 0);
                }
            }
        }

        static bool rossz(int i, int j, bool[,] Sz, int[] Y)
        {
            int k = 1;
            while (k < i && (Y[k - 1] != j || !Sz[k - 1,i - 1]))
            {
                k++;
            }
            return k < i;
        }
        
        static void Jóesetkeresés(int i, bool[,] Sz, int K,  int[] Y, out bool Van, ref int j)
        {
            j = Y[i - 1] + 1;
            while (j <= K && (rossz(i, j, Sz, Y)))
            {
                j++;
            }
            Van = j <= K;
        }

        static void Térkép(int N, bool[,] Sz, int K, out bool Van, int[] Y)
        {
            for (int ii = 0; ii < N; ii++)
            {
                Y[ii] = 0;
            }
            int i = 1;
            while (i >= 1 && i <= N)
            {
                int j = 0;
                Jóesetkeresés(i, Sz, K, Y, out Van, ref j);
                if (Van)
                {
                    Y[i - 1] = j;
                    i++;
                }
                else
                {
                    Y[i - 1] = 0;
                    i--;
                }
            }
            Van = i > N;
        }

        static void Kiírás(int N, bool Van, int[] Y)
        {
            //A kimenetet kísérő szövegek is az Error csatornára irandók!
            if (Van)
            {
                for (int i = 0; i < N; i++)
                {
                    Console.WriteLine(Y[i] + " ");
                }
                Console.WriteLine();
            }
            else
            {
                Console.WriteLine("Nincs helyes megoldás!");
            }
        }

        static void Main(string[] args)
        {
            //Térképszínezés
            //Maximális elemszám
            const int MaxN = 100;
            //A munkások száma
            int N;
            int K;
            //A mátrix deklarálása
            bool[,] Sz = new bool[MaxN, MaxN]; //Szomszédok
            //Kieneti adatok deklarálása
            bool Van;
            int[] Y = new int[MaxN];//Területszínek
            //Beolvasás
            Beolvasás(out N, Sz, out K);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            //Lényegi megoldás
            Térkép(N,Sz,K,out Van,Y);
            //Kiírás
            Kiírás(N, Van, Y);
        }
    }
}
