//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxN = 100;

    static class Input {
        int N;
        boolean[][] Sz = new boolean[MaxN][MaxN];
        int K;
    }

    static class Output {
        boolean Van;
        int[] Y = new int[MaxN];
    }

    static class JoesetkeresesResponse {
        boolean Van;
        int j;
    }

    static Input beolvas(IO io) throws IOException {
        PrintStream cerr = System.err;
        Input input = new Input();
        cerr.print("Teruletek szama (1<=N<=100) = ");
        input.N = io.nextInt();
        cerr.print("Szinek szama (1<=K<=100) = ");
        input.K = io.nextInt();
        for (int i = 0; i < input.N; i++) {
            cerr.println((i + 1) + ". terulet szomszedos-e");
            for (int j = 0; j < input.N; j++) {
                int sv;
                cerr.print("  a(z) " + (j + 1) + ". terulettel (0 - nem, 1 - igen) = ");
                sv = io.nextInt();
                input.Sz[i][j] = (sv > 0);
            }
        }
        return input;
    }

    static void kiir(IO io, Input input, Output output) throws IOException {
        if (output.Van) {
            for (int i = 1; i <= input.N; i++) {
                io.write(output.Y[i - 1] + " ");
            }
            io.writeLn("");
        } else {
            io.writeLn("Nincs helyes megoldas");
        }
    }

    static boolean rossz(int i, int j, boolean[][] Sz, int[] Y) {
        int k = 1;
        while ((k < i) && ((Y[k - 1] != j) || !Sz[k - 1][i - 1])) {
            k = k + 1;
        }
        return k < i;
    }

    static JoesetkeresesResponse Joesetkereses(int i, Input input, int Y[]) {
        PrintStream cerr = System.err;
        JoesetkeresesResponse response = new JoesetkeresesResponse();
        response.j = Y[i - 1] + 1;
        while ((response.j <= input.K) && rossz(i, response.j, input.Sz, Y)) {
            response.j++;
        }
        response.Van = (response.j <= input.K);
        return response;
    }

    static Output Terkep(Input input) {
        Output output = new Output();
        for (int i = 0; i <= input.N - 1; i++) {
            output.Y[i] = 0;
        }
        int i = 1;
        while (i >= 1 && i <=input.N){
            int j;
            JoesetkeresesResponse joesetkeresesResponse = Joesetkereses(i, input, output.Y);
            if (joesetkeresesResponse.Van) {
                output.Y[i - 1] = joesetkeresesResponse.j;
                i++;
            } else {
                output.Y[i - 1] = 0;
                i--;
            }
        }
        output.Van = (i > input.N);
        return output;
    }

    public static void main(String[] args) throws Exception {
        IO io = new IO();

        Input input = beolvas(io);

        Output output = Terkep(input);

        kiir(io, input, output);

        io.close();
    }

}