(*
* Feladat: Munkásfelvétel: N állás – N jelentkező
* 
* Bemenet:
*  	N – a munkák és a jelentkezők száma
•   F – az adott jelentkezők mely munkákhoz értenek (F[i,j] – az i. jelentkező által elvégezhető j. munka ára)
•   X – a rendelkezésre álló összeg
* Kimenet:
•   Y – az aktuálisan számolt megoldás: Y[i] az i. jelentkezőnek adott munka sorszáma
*
*)
Program Munkak_Program;
  Const
    MaxN=100;//a munkák=jelentkezők maximális száma
  Type
    TEgeszek=Array [1..MaxN] of Word;
    TEgeszMatrix=Array [1..MaxN,0{!!!}..MaxN] of Word;
  Var
    //Bemenet
    N:Integer;//munkák=jelentkezők száma
    F:TEgeszMatrix;//a jelentkező mely munkákhoz értenek 
    X:Word;//a rendelkezésre álló összeg
    //Kimenet:
    Van:Boolean;//van-e megoldás
	Y:TEgeszek;//jelentkezőknek adott munkák sorszámai
	
  Procedure Beolvasas(Var N:Integer; Var X:Word; Var F:TEgeszMatrix);
    Var
      i,j:Integer;
  Begin
    Write(StdErr,'Munkak szama (0..',MaxN,') es a maximalis osszeg (0..',MaxInt,'):'); Readln(N,X);
	Writeln(StdErr,'Munkasok fizetesigenyei a(z) ',N,' munkahoz:');
	For i:=1 to N do
	Begin
	  Write(StdErr,i,'. munkas:');
	  F[i,0]:=0; {!!!}
	  For j:=1 to N do Read(F[i,j]);
	  Readln;
	End;
  End;
  
  Function Koltseg(Const F:TEgeszMatrix; Const Y:TEgeszek; Const i:Integer):Word;
    Var
      s,j:Word;
  Begin
    s:=0;
    For j:=1 to N do s:=s+F[i,Y[j]];
    Koltseg:=s;
  End;
  
  Function Rossz(Const i:Integer; Const j:Integer):Boolean;
    Var
      k:Integer;
  Begin
    k:=1;
    While (k<i) and (Y[k]<>j) do Inc(k);
    Rossz:=k<i;
  End;
  
  Procedure Joesetkereses(Const i:Integer; Var Van:Boolean; Var j:Integer);
  Begin
    j:=Y[i]+1;
    While (j<=N) and (Rossz(i,j) or (F[i,j]=0)) do Inc(j);
    Van:=j<=N;
  End;
  
  Procedure Munkak(Const N:Integer; Const X:Word; Const F:TEgeszMatrix; Var Van:Boolean; Var Y:TEgeszek);
    Var
      i,j:Integer;
  Begin
    i:=1; For j:=1 to N do Y[j]:=0;
    While (i>=1) and (i<=N) do
    Begin
      Joesetkereses(i,Van,j);
      If Van and (Koltseg(F,Y,i)<=X) then 
      Begin
        Y[i]:=j; Inc(i);
      End
        else
      Begin
        Y[i]:=0; Dec(i);
      End;
    End;
    Van:=i>N;
  End;
  
  Procedure Kiiras(Const N:Integer; Const Van:Boolean; Const Y:TEgeszek);
    Var
      i:Integer;
  Begin
    If Van then
    Begin
      For i:=1 to N do
      Begin
        Write(Y[i],' ');
      End;
      Writeln;
    End
      else
    Begin
      Writeln('NINCS');
    End;
  End;

Begin
  Beolvasas(N,X,F);
  Munkak(N,X,F,Van,Y);
  Kiiras(N,Van,Y);
End.
