(*
* Feladat: Munkásfelvétel: N ország – szomszédosak különböző színnel
* 
* Bemenet:
*  	N – a térkép színezendő területeinek a száma
•   Sz – szomszédsági mátrix
•   K – a használható színek száma
* Kimenet:
•   Y – a megoldás: Y[i] az i. terület színsorszáma
*
*)
Program Terkepszinezes_Program;
  Const
    MaxN=100;//a területek maximális száma
  Type
    TEgeszek=Array [1..MaxN] of Integer;
    TSzomszedsagiMatrix=Array [1..MaxN,1..MaxN] of Boolean;
  Var
    //Bemenet
    N:Integer;//területek száma
    Sz:TSzomszedsagiMatrix;//a szomszédsági mátrix
    K:Byte;//haszbálható színek száma
    //Kimenet:
    Van:Boolean;//van-e megoldás
	Y:TEgeszek;//a területek színsorszámai
	
  Procedure Beolvasas(Var N:Integer; Var K:Byte; Var Sz:TSzomszedsagiMatrix);
    Var
      i,j:Integer;
      x:Integer;
  Begin
    Write(StdErr,'Teruletek szama (0..',MaxN,') es a maximalis szinek szama (0..4):'); Readln(N,K);
	Writeln(StdErr,'Szomszedsagi matrix:');
	For i:=1 to N do
	Begin
	  Write(StdErr,i,'. terulet szomszedsaga a tobbivel (1, ha szomszedos; 0, kulonben):');
	  For j:=1 to N do
	  Begin
	    Read(x); Sz[i,j]:=x=1;
	  End;
	  Readln;
	End;
  End;

  Function Rossz(Const Sz:TSzomszedsagiMatrix; Const i:Integer; Const j:Integer):Boolean;
    Var
      k:Integer;
  Begin
    k:=1;
    While (k<i) and ((Y[k]<>j) or not Sz[k,i]) do Inc(k);
    Rossz:=k<i;
  End;
  
  Procedure Joesetkereses(Const i,K:Integer; Const Sz:TSzomszedsagiMatrix;
                          Var Van:Boolean; Var j:Integer);
  Begin
    j:=Y[i]+1;
    While (j<=K) and Rossz(Sz,i,j) do Inc(j);
    Van:=j<=K;
  End;
  
  Procedure Terkep(Const N:Integer; Const K:Byte; Const Sz:TSzomszedsagiMatrix;
                   Var Van:Boolean; Var Y:TEgeszek);
    Var
      i,j:Integer;
  Begin
    i:=1; For j:=1 to N do Y[j]:=0;
    While (i>=1) and (i<=N) do
    Begin
      Joesetkereses(i,K,Sz,Van,j);
      If Van then 
      Begin
        Y[i]:=j; Inc(i);
      End
        else
      Begin
        Y[i]:=0; Dec(i);
      End;
    End;
    Van:=i>N;
  End;
  
  Procedure Kiiras(Const N:Integer; Const Van:Boolean; Const Y:TEgeszek);
    Var
      i:Integer;
  Begin
    If Van then
    Begin
      For i:=1 to N do
      Begin
        Write(Y[i],' ');
      End;
      Writeln;
    End
      else
    Begin
      Writeln('NINCS');
    End;
  End;

Begin
  Beolvasas(N,K,Sz);
  Terkep(N,K,Sz,Van,Y);
  Kiiras(N,Van,Y);
End.
